import type { QueryKey } from "@tanstack/react-query";
type Query = Partial<{
    list: Function;
    detail: Function;
    [key: string]: Function;
}>;
type Mutation = Partial<{
    create: Function;
    update: Function;
    delete: Function;
    [key: string]: Function;
}>;
export type CreateInput<Q extends Query, M extends Mutation> = {
    root: QueryKey;
    query: Q;
    mutation: M;
};
export type Store<Q extends Query, M extends Mutation> = {
    key: {
        root: QueryKey;
        base: Record<keyof Q, QueryKey>;
        generator: Record<keyof Q, (queryKey?: QueryKey) => QueryKey>;
    };
    query: Q;
    mutation: M;
};
export declare const create: <Q extends Query, M extends Mutation>(input: Partial<CreateInput<Q, M>>) => Store<Q, M>;
export {};
